'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.processLinks = exports.readFile = exports.attachStats = exports.parseFile = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _parser = require('./parser');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var store = {};
var parseFile = exports.parseFile = function parseFile(filePath, result) {
  store = result;
  var html = _fs2.default.readFileSync(filePath, "utf8");
  return processHTML(html, filePath);
};
var processHTML = function processHTML(html, filePath) {
  (0, _parser.parse)(html, store, filePath);
  var links = _.keys(store);
  var values = _.values(store);
  var p = [];
  if (_.find(values, function (value) {
    return !value.status;
  })) {
    p = links.map(processLinks);
  }
  return Promise.all(p);
};
var attachStats = exports.attachStats = function attachStats(link) {
  var ast = store[link];
  return new Promise(function (resolve, reject) {
    _fs2.default.stat(ast.urlObject.absPath, function (err, data) {
      if (err) {
        ast.status = 'error';
        reject(err);
      }
      ast.fileStats = data;
      resolve(data);
    });
  });
};
var readFile = exports.readFile = function readFile(link) {
  var ast = store[link];
  return new Promise(function (resolve, reject) {
    _fs2.default.readFile(link, "utf8", function (err, data) {
      if (err) {
        reject(err);
      }
      ast.fileContents = data;
      processHTML(data, link).then(function () {
        resolve();
      });
    });
  });
};
var processLinks = exports.processLinks = function processLinks(link, i) {
  var ast = store[link];
  if (!ast.status && ast.urlObject.local) {
    ast.status = 'working';
    var statsPromise = attachStats(link);
    return Promise.all([attachStats(link), readFile(link)]);
  }
};